//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Client.ListDataTypeTest.ListDataTypeTest
{
    
    
    /// <summary>
    /// Class that implements the IListDataTypeTest interface through SiLA2
    /// </summary>
    public partial class ListDataTypeTestClient : IListDataTypeTest
    {
        
        private System.Lazy<System.Collections.Generic.ICollection<string>> _emptyStringList;
        
        private System.Lazy<System.Collections.Generic.ICollection<string>> _stringList;
        
        private System.Lazy<System.Collections.Generic.ICollection<long>> _integerList;
        
        private System.Lazy<System.Collections.Generic.ICollection<TestStructure>> _structureList;
        
        private IClientExecutionManager _executionManager;
        
        private IClientChannel _channel;
        
        private const string _serviceName = "sila2.org.silastandard.test.listdatatypetest.v1.ListDataTypeTest";
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="channel">The channel through which calls should be executed</param>
        /// <param name="executionManager">A component to determine metadata to attach to any requests</param>
        public ListDataTypeTestClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            _executionManager = executionManager;
            _channel = channel;
            InitLazyRequests();
        }
        
        /// <summary>
        /// Returns an empty list of String type.
        /// </summary>
        public virtual System.Collections.Generic.ICollection<string> EmptyStringList
        {
            get
            {
                return _emptyStringList.Value;
            }
        }
        
        /// <summary>
        /// Returns a list with the following string values: 'SiLA 2', 'is', 'great'.
        /// </summary>
        public virtual System.Collections.Generic.ICollection<string> StringList
        {
            get
            {
                return _stringList.Value;
            }
        }
        
        /// <summary>
        /// Returns a list with the following Integer values: 1, 2, 3.
        /// </summary>
        public virtual System.Collections.Generic.ICollection<long> IntegerList
        {
            get
            {
                return _integerList.Value;
            }
        }
        
        /// <summary>
        /// Returns a list with 3 structure values, whereas the values of the first element are:
        /// string value = 'SiLA2_Test_String_Value_1'
        /// integer value = 5124
        /// real value = 3.1415926
        /// boolean value = true
        /// binary value (embedded string) = 'Binary_String_Value_1'
        /// date value = 05.08.2022 respective 08/05/2022
        /// time value = 12:34:56
        /// time stamp value = 2022-08-05 12:34:56.
        /// any type value (string) = 'Any_Type_String_Value_1'
        /// For the second and third element:
        /// the last character of the strings changes to '2' respective '3'
        /// the numeric values are incremented by 1
        /// the boolean values becomes false for element 2 and true for element 3
        /// for the date value day, month and year are incremented by 1
        /// for the time value seconds, minutes and hours are incremented by 1
        /// for the time stamp value day, month, year, seconds, minutes and hours are incremented by 1.
        /// </summary>
        public virtual System.Collections.Generic.ICollection<TestStructure> StructureList
        {
            get
            {
                return _structureList.Value;
            }
        }
        
        private System.Collections.Generic.ICollection<string> RequestEmptyStringList()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/ListDataTypeTest/v1/Property/EmptyStringList");
            try
            {
                System.Collections.Generic.ICollection<string> response = _channel.ReadProperty<PropertyResponse<System.Collections.Generic.List<Tecan.Sila2.StringDto>>>(_serviceName, "EmptyStringList", "org.silastandard/test/ListDataTypeTest/v1/Property/EmptyStringList", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private System.Collections.Generic.ICollection<string> RequestStringList()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/ListDataTypeTest/v1/Property/StringList");
            try
            {
                System.Collections.Generic.ICollection<string> response = _channel.ReadProperty<PropertyResponse<System.Collections.Generic.List<Tecan.Sila2.StringDto>>>(_serviceName, "StringList", "org.silastandard/test/ListDataTypeTest/v1/Property/StringList", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private System.Collections.Generic.ICollection<long> RequestIntegerList()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/ListDataTypeTest/v1/Property/IntegerList");
            try
            {
                System.Collections.Generic.ICollection<long> response = _channel.ReadProperty<PropertyResponse<System.Collections.Generic.List<Tecan.Sila2.IntegerDto>>>(_serviceName, "IntegerList", "org.silastandard/test/ListDataTypeTest/v1/Property/IntegerList", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private System.Collections.Generic.ICollection<TestStructure> RequestStructureList()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/ListDataTypeTest/v1/Property/StructureList");
            try
            {
                System.Collections.Generic.ICollection<TestStructure> response = _channel.ReadProperty<PropertyResponse<System.Collections.Generic.List<TestStructureDto>>>(_serviceName, "StructureList", "org.silastandard/test/ListDataTypeTest/v1/Property/StructureList", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Initializes lazies for non-observable properties.
        /// </summary>
        private void InitLazyRequests()
        {
            _emptyStringList = new System.Lazy<System.Collections.Generic.ICollection<string>>(RequestEmptyStringList);
            _stringList = new System.Lazy<System.Collections.Generic.ICollection<string>>(RequestStringList);
            _integerList = new System.Lazy<System.Collections.Generic.ICollection<long>>(RequestIntegerList);
            _structureList = new System.Lazy<System.Collections.Generic.ICollection<TestStructure>>(RequestStructureList);
        }
        
        /// <summary>
        /// Receives a list of string values and returns a list containing the string values that have been received.
        /// </summary>
        /// <param name="stringList">The list of string values to be returned.</param>
        public virtual System.Collections.Generic.ICollection<string> EchoStringList(System.Collections.Generic.ICollection<string> stringList)
        {
            EchoStringListRequestDto request = new EchoStringListRequestDto(stringList, null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/ListDataTypeTest/v1/Command/EchoStringList");
            try
            {
                System.Collections.Generic.ICollection<string> response = _channel.ExecuteUnobservableCommand<EchoStringListRequestDto, EchoStringListResponseDto>(_serviceName, "EchoStringList", request, callInfo).ReceivedValues.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Receives a list of integer values and returns a list containing the integer values that have been received.
        /// </summary>
        /// <param name="integerList">The list of integer values to be returned.</param>
        public virtual System.Collections.Generic.ICollection<long> EchoIntegerList(System.Collections.Generic.ICollection<long> integerList)
        {
            EchoIntegerListRequestDto request = new EchoIntegerListRequestDto(integerList, null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/ListDataTypeTest/v1/Command/EchoIntegerList");
            try
            {
                System.Collections.Generic.ICollection<long> response = _channel.ExecuteUnobservableCommand<EchoIntegerListRequestDto, EchoIntegerListResponseDto>(_serviceName, "EchoIntegerList", request, callInfo).ReceivedValues.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Receives a list of structure values and returns a list containing the structures that have been received.
        /// </summary>
        /// <param name="structureList">The list of structure values to be returned.</param>
        public virtual System.Collections.Generic.ICollection<TestStructure> EchoStructureList(System.Collections.Generic.ICollection<TestStructure> structureList)
        {
            EchoStructureListRequestDto request = new EchoStructureListRequestDto(structureList, _executionManager.CreateBinaryStore("org.silastandard/test/ListDataTypeTest/v1/Command/EchoStructureList/Parameter/Str" +
                        "uctureList"));
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/ListDataTypeTest/v1/Command/EchoStructureList");
            try
            {
                System.Collections.Generic.ICollection<TestStructure> response = _channel.ExecuteUnobservableCommand<EchoStructureListRequestDto, EchoStructureListResponseDto>(_serviceName, "EchoStructureList", request, callInfo).ReceivedValues.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private T Extract<T>(Tecan.Sila2.ISilaTransferObject<T> dto)
        
        {
            return dto.Extract(_executionManager.DownloadBinaryStore);
        }
    }
    
    /// <summary>
    /// Factory to instantiate clients for the List Data Type Test.
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IClientFactory))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class ListDataTypeTestClientFactory : IClientFactory
    {
        
        /// <summary>
        /// Gets the fully-qualified identifier of the feature for which clients can be generated
        /// </summary>
        public string FeatureIdentifier
        {
            get
            {
                return "org.silastandard/test/ListDataTypeTest/v1";
            }
        }
        
        /// <summary>
        /// Gets the interface type for which clients can be generated
        /// </summary>
        public System.Type InterfaceType
        {
            get
            {
                return typeof(IListDataTypeTest);
            }
        }
        
        /// <summary>
        /// Creates a strongly typed client for the given execution channel and execution manager
        /// </summary>
        /// <param name="channel">The channel that should be used for communication with the server</param>
        /// <param name="executionManager">The execution manager to manage metadata</param>
        /// <returns>A strongly typed client. This object will be an instance of the InterfaceType property</returns>
        public object CreateClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            return new ListDataTypeTestClient(channel, executionManager);
        }
    }
}

